unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, SvcMgr, Dialogs, inifiles,
  IdBaseComponent, IdComponent, IdUDPBase, IdUDPServer,IdSocketHandle, shellapi,
  abfComponents;

type
  Twudown = class(TService)
    udps1: TIdUDPServer;
    sd1: TabfShutdown;
    procedure ServiceCreate(Sender: TObject);
    procedure udps1UDPRead(Sender: TObject; AData: TStream;
      ABinding: TIdSocketHandle);
  private
    { Private declarations }
  public
    function GetServiceController: TServiceController; override;
    { Public declarations }
  end;

var
  wudown: Twudown;
  appath:string;
  pass,execc:string;


implementation

{$R *.DFM}

procedure ServiceController(CtrlCode: DWord); stdcall;
begin
  wudown.Controller(CtrlCode);
end;

function Twudown.GetServiceController: TServiceController;
begin
  Result := ServiceController;
end;

procedure Twudown.ServiceCreate(Sender: TObject);
const
   n='wudown';
var
  z:TIniFile;
begin
   appath:=ExtractFilePath(ParamStr(0));
   z:=tinifile.Create(appath+'settings.ini');
   udps1.DefaultPort:=z.ReadInteger(n,'port',1209);
   pass:=z.ReadString(n,'pass','shutdown');
   execc:=z.ReadString(n,'exec','');
   z.Free;
   udps1.Active:=true;
end;

procedure Twudown.udps1UDPRead(Sender: TObject; AData: TStream;
  ABinding: TIdSocketHandle);
var
  ts:TStringStream;
  s:string;
  f:TextFile;
begin

   ts:=TStringStream.Create('');
   ts.CopyFrom(adata,AData.Size);
   s:=ts.DataString;
   ts.Free;
   if (s=pass) then
   begin
     AssignFile(f,appath+'log.txt');
     if FileExists(appath+'log.txt') then Append(f) else Rewrite(f);
     Writeln(f,datetostr(date)+':'+timetostr(time)+' shutdown command recived form '+ABinding.peerip);
     CloseFile(f);
     if execc<>'' then begin
       ShellExecute(0,'open',PChar(execc),'',PChar(ExtractFilePath(execc)),SW_SHOWNORMAL);
       Exit;
     end;
     sd1.Execute;


   end;
end;

end.
